"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Transaction = (function () {
    function Transaction(hint) {
        this.id = 0;
        this._snapshot = 0;
        this.changeset = new Map();
        this.pending = 0;
        this.sealed = false;
        this._error = undefined;
        this.resultPromise = undefined;
        this.resultResolve = function () { };
        this.resultReject = function () { };
        this.conflicts = undefined;
        this.refreshments = [];
        this.id = ++Transaction.id;
        this.hint = hint || "noname";
    }
    Object.defineProperty(Transaction.prototype, "snapshot", {
        get: function () { return this._snapshot; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transaction.prototype, "error", {
        get: function () { return this._error; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transaction, "current", {
        get: function () {
            return Ctx.transaction;
        },
        enumerable: true,
        configurable: true
    });
    Transaction.prototype.run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this.sealed && Ctx.transaction !== this)
            throw new Error("E601: cannot run sealed transaction");
        return this._run.apply(this, [func].concat(args));
    };
    Transaction.prototype.wrap = function (func) {
        return Transaction._wrap(this, Ctx.cache, true, true, func);
    };
    Transaction.prototype.commit = function () {
        if (this.pending > 0)
            throw new Error("E602: cannot commit transaction having pending async operations");
        if (this._error)
            throw new Error("E603: cannot commit discarded transaction: " + this._error);
        this.sealToCommit();
    };
    Transaction.prototype.sealToCommit = function () {
        if (!this.sealed)
            this.run(Transaction.seal, this);
        return this;
    };
    Transaction.prototype.discard = function (error) {
        if (error === void 0) { error = "transaction discarded"; }
        if (!this._error)
            this._error = error;
        if (!this.sealed)
            this.run(Transaction.seal, this);
        return this;
    };
    Transaction.prototype.waitForFinish = function () {
        return this.acquirePromise();
    };
    Transaction.prototype.finished = function () {
        return this.sealed && this.pending === 0;
    };
    Transaction.prototype.undo = function () {
        throw new Error("not implemented");
    };
    Transaction.prototype.redo = function () {
        throw new Error("not implemented");
    };
    Transaction.run = function (hint, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var t = Ctx.transaction || new Transaction(hint);
        var result;
        try {
            result = t.run.apply(t, [func].concat(args));
            t.sealAndRethrowErrorIfNeeded();
        }
        catch (error) {
            t.discard(error);
            throw error;
        }
        return result;
    };
    Transaction.runAsync = function (hint, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var t, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        t = Ctx.transaction || new Transaction(hint);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, t.run.apply(t, [func].concat(args))];
                    case 2:
                        result = _a.sent();
                        t.sealAndRethrowErrorIfNeeded();
                        return [3, 4];
                    case 3:
                        error_1 = _a.sent();
                        t.discard(error_1);
                        throw error_1;
                    case 4: return [2, result];
                }
            });
        });
    };
    Transaction.prototype._run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var outer = Ctx.transaction;
        var result;
        try {
            this.pending++;
            Ctx.transaction = this;
            result = func.apply(void 0, args);
            if (this.sealed && this.pending === 1 && !this._error)
                this.checkConflictsResolved();
        }
        catch (e) {
            this._error = this._error || e;
            throw e;
        }
        finally {
            this.pending--;
            if (this.finished()) {
                if (!this._error)
                    this.performCommit();
                else
                    this.performDiscard();
                Object.freeze(this.changeset);
                Object.freeze(this);
            }
            Ctx.transaction = outer;
        }
        if (this.finished())
            for (var _a = 0, _b = this.refreshments; _a < _b.length; _a++) {
                var x = _b[_a];
                x.refresh(false);
            }
        return result;
    };
    Transaction.prototype.sealAndRethrowErrorIfNeeded = function () {
        if (!Ctx.transaction)
            this.sealToCommit();
        if (this.finished() && this._error)
            throw this._error;
    };
    Transaction.seal = function (t) {
        t.sealed = true;
    };
    Transaction.prototype.checkConflictsResolved = function () {
        var _this = this;
        this.conflicts = undefined;
        this.changeset.forEach(function (r, h) {
            if (r.determineConflicts()) {
                if (!_this.conflicts)
                    _this.conflicts = [];
                _this.conflicts.push(r);
            }
        });
        if (this.conflicts)
            this.tryResolveConflicts(this.conflicts);
    };
    Transaction.prototype.tryResolveConflicts = function (conflicts) {
        this._error = this._error || new Error(this.hint + " conflicts with other transactions on: " + Tools.formatConflictsSummary(conflicts));
    };
    Transaction._acquireSnapshotNumber = function (t) {
        if (t._snapshot === 0) {
            t._snapshot = Ctx.snapshot;
            Tools.log(37, "╔═══", "v" + t.snapshot, t.hint + " - begin");
        }
        return t._snapshot;
    };
    Transaction.prototype.performCommit = function () {
        var _this = this;
        if (this.changeset.size > 0) {
            this._snapshot = ++Ctx.snapshot;
            Handle.applyChangeset(true, this.changeset);
            Tools.log(37, this.snapshot > 0 ? "╚═══" : "═══", "v" + this.snapshot, this.hint + " - end (COMMIT)");
            if (this.resultPromise)
                this.resultResolve();
            this.changeset.forEach(function (r, h) { return r.notifyObservers(_this.refreshments); });
        }
        else if (this.resultPromise) {
            this.resultResolve();
            Tools.log(37, this.snapshot > 0 ? "╚═══" : "═══", "v" + this.snapshot, this.hint + " - end (DRY)");
        }
    };
    Transaction.prototype.performDiscard = function () {
        Handle.applyChangeset(false, this.changeset);
        if (this.resultPromise)
            this.resultReject(this._error);
        Tools.log(31, "╚═══", "v" + this.snapshot, this.hint + " - end (DISCARD) " + this._error);
    };
    Transaction.prototype.acquirePromise = function () {
        var _this = this;
        if (!this.resultPromise) {
            this.resultPromise = new Promise(function (resolve, reject) {
                _this.resultResolve = resolve;
                _this.resultReject = reject;
            });
        }
        return this.resultPromise;
    };
    Transaction._changeset = function (t) {
        return t.changeset;
    };
    Transaction._wrap = function (t, c, inc, dec, func) {
        var f = c ? c.wrap(func) : func;
        if (inc)
            t.run(function () { return t.pending++; });
        var tran = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return t._run(function () {
                if (dec)
                    t.pending--;
                return f.apply(void 0, args);
            });
        };
        return tran;
    };
    Transaction.id = 9;
    return Transaction;
}());
exports.Transaction = Transaction;
var StoreParams = (function () {
    function StoreParams() {
    }
    return StoreParams;
}());
exports.StoreParams = StoreParams;
var Store = (function () {
    function Store(params) {
        this.params = params || {};
    }
    Store.dispose = function (obj) {
    };
    return Store;
}());
exports.Store = Store;
var VARIO = Symbol("vario");
var VARIO_VMT = Symbol("vario-vmt");
var VARIO_DISPOSED = Symbol("vario-disposed");
var Handle = (function () {
    function Handle(store, proxy) {
        var _this = this;
        this.editable = undefined;
        this.editors = 0;
        var data = {};
        this.id = ++Handle.id;
        this.store = store;
        this.proxy = proxy;
        this.committed = new Record(this, undefined, Ctx.zerotran, data);
        var vmt = proxy[VARIO_VMT] || new Map();
        vmt.forEach(function (method, prop) {
            return data[prop] = new Cache(_this.committed, method, -1, 0);
        });
        this.committed.freeze();
    }
    Handle.prototype.getCommitted = function () {
        return this.committed;
    };
    Handle.prototype.getRelevant = function (t, c) {
        Transaction._acquireSnapshotNumber(t);
        var result = this.editable;
        if (result && result.transaction !== t) {
            result = Transaction._changeset(t).get(this);
            if (result)
                this.editable = result;
        }
        if (!result) {
            result = this.committed;
            while (!result.isVoid && result.transaction.snapshot > t.snapshot)
                result = result.previous;
        }
        return result;
    };
    Handle.prototype.getForView = function () {
        var t = Ctx.transaction;
        var result = t ? this.getRelevant(t, Ctx.cache) : this.committed;
        if (!result)
            throw new Error("E607: internal error");
        return result;
    };
    Handle.prototype.getForEdit = function (prop, value) {
        var c = Ctx.cache;
        if (c && !c.method.isTran && c.owner.handle !== this && value !== VARIO)
            throw new Error("E608: object cannot be changed outside of cache function");
        var t = Ctx.transaction;
        if (!t)
            throw new Error("E609: object cannot be changed outside of transaction");
        var r = this.getRelevant(t, c);
        if (!r || Tools.notEqual(r.data[prop], value)) {
            var data = r ? r.data : value;
            if (!r || r.transaction !== t) {
                data = __assign({}, data);
                r = new Record(this, this.committed, t, data);
                Transaction._changeset(t).set(this, r);
                this.editable = r;
                this.editors++;
            }
            var v = r.previous.data[prop];
            r.registerPropEdit(prop, Tools.notEqual(v, value) && value !== VARIO);
        }
        else
            r = undefined;
        return r;
    };
    Handle.prototype.getForRenew = function (prop) {
        var result = this.getForEdit(prop, VARIO);
        if (!result)
            throw new Error("unknown error");
        return result;
    };
    Handle.applyChangeset = function (commit, changeset) {
        changeset.forEach(function (r, h) {
            r.freeze();
            h.editors--;
            if (h.editors === 0)
                h.editable = undefined;
            if (commit)
                h.committed = r;
            var props = [];
            r.changes.forEach(function (prop) { return props.push(prop.toString()); });
            Tools.log(32, "║", "M", r.hint() + ": " + props.join(", "));
        });
    };
    Handle.prototype.dispose = function () {
        var _this = this;
        Transaction.run(this.hint + ".dtor", function () { return _this.getForEdit(VARIO_DISPOSED, VARIO_DISPOSED); });
    };
    Object.defineProperty(Handle.prototype, "hint", {
        get: function () { return this.proxy.constructor.name + "#" + this.id; },
        enumerable: true,
        configurable: true
    });
    Handle.id = 10;
    return Handle;
}());
var Ctx = (function () {
    function Ctx() {
    }
    Ctx.snapshot = 10;
    Ctx.transaction = undefined;
    Ctx.cache = undefined;
    Ctx.store = new Store({ name: "vario" });
    Ctx.zerotran = new Transaction("notran");
    return Ctx;
}());
var Record = (function () {
    function Record(handle, previous, tran, data) {
        this.handle = handle;
        this.previous = previous || this;
        this.transaction = tran;
        this.data = data;
        this.changes = new Set();
        this.conflicts = new Map();
        this.observers = new Map();
        this.dirty = new Set();
    }
    Object.defineProperty(Record.prototype, "isVoid", {
        get: function () { return this.previous === this; },
        enumerable: true,
        configurable: true
    });
    Record.prototype.freeze = function () {
        var _this = this;
        Object.freeze(this.data);
        this.changes.forEach(function (prop) {
            var val = _this.data[prop];
            if (Array.isArray(val) && !Object.isFrozen(val))
                Tools.freezeArray(val, { object: _this.handle.proxy, property: prop });
        });
        Object.freeze(this.changes);
        Object.freeze(this.conflicts);
        Object.freeze(this);
    };
    Record.prototype.registerPropView = function (prop, cache) {
        if (cache && !cache.method.isTran) {
            if (!cache.dirty && this.dirty.has(prop))
                cache.dirty = this.hint(prop);
            Tools.link(prop, this, this.observers, cache, cache.observables);
        }
    };
    Record.prototype.registerPropEdit = function (prop, changed) {
        changed ? this.changes.add(prop) : this.changes.delete(prop);
    };
    Record.prototype.determineConflicts = function () {
        var _this = this;
        var committed = this.handle.getCommitted();
        if (committed.transaction.snapshot > this.transaction.snapshot) {
            this.changes.forEach(function (prop) {
                var theirs = committed;
                while (!theirs.isVoid && theirs.transaction.snapshot > _this.transaction.snapshot) {
                    if (theirs.changes.has(prop)) {
                        if (Tools.notEqual(theirs.data[prop], _this.data[prop]))
                            _this.conflicts.set(prop, theirs);
                        theirs = _this;
                    }
                    else
                        theirs = theirs.previous;
                }
            });
        }
        return this.conflicts.size > 0;
    };
    Record.prototype.notifyObservers = function (refreshments) {
        var _this = this;
        var affected = 0;
        this.changes.forEach(function (prop) {
            _this.previous.dirty.add(prop);
            var c = _this.data[prop];
            if (c instanceof Cache && c.dirty)
                affected += c.invalidate(c.dirty, refreshments);
        });
        this.previous.observers.forEach(function (observers, prop) {
            if (!_this.changes.has(prop))
                _this.observers.set(prop, new Set(observers.keys()));
            else
                affected += Record.notifyObserversIfAny(_this.hint(prop), observers, refreshments);
            observers.clear();
        });
        return affected;
    };
    Record.notifyObserversIfAny = function (invalidator, observers, refreshments) {
        var affected = 0;
        if (observers)
            observers.forEach(function (x) {
                affected += x.invalidate(invalidator, refreshments);
            });
        return affected;
    };
    Record.prototype.hint = function (prop) {
        return prop !== undefined ?
            this.handle.hint + "t" + this.transaction.id + "." + prop.toString() :
            this.handle.hint + "t" + this.transaction.id;
    };
    return Record;
}());
var MethodInfo = (function () {
    function MethodInfo(isTran, name, body) {
        this.isTran = isTran;
        this.isAsync = Tools.isAsync(body);
        this.name = name;
        this.body = body;
        Object.freeze(this);
    }
    return MethodInfo;
}());
var Cache = (function () {
    function Cache(owner, method, latency, margin) {
        this.owner = owner;
        this.method = method;
        this.trap = this.createTrap();
        this.observables = new Map();
        this.args = [];
        this.value = undefined;
        this.invalidator = owner.hint(VARIO);
        this.dirty = undefined;
        this.error = undefined;
        this.latency = latency;
        this.margin = margin;
    }
    Cache.prototype.run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var outer = Ctx.cache;
        try {
            Ctx.cache = this;
            return func.apply(void 0, args);
        }
        catch (e) {
            this.error = e;
            throw e;
        }
        finally {
            Ctx.cache = outer;
        }
    };
    Cache.prototype.wrap = function (func) {
        var _this = this;
        var caching = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.run.apply(_this, [func].concat(args));
        };
        return caching;
    };
    Cache.prototype.invalidate = function (invalidator, refreshments) {
        var result = 0;
        var t = this.owner.transaction;
        if (this.invalidator === undefined && (t.finished() || t === Ctx.transaction)) {
            this.invalidator = invalidator;
            if (this.latency >= 0 && refreshments)
                refreshments.push(this);
            result = 1;
            Tools.log(36, "", this.latency >= 0 && refreshments ? " ■" : " i", this.hint + " is invalidated by " + this.invalidator);
            var owner = this.owner.handle.getCommitted();
            while (!owner.isVoid && owner.data[this.method.name] === this) {
                result += Record.notifyObserversIfAny(this.owner.hint(this.method.name), owner.observers.get(this.method.name), refreshments);
                owner = owner.previous;
            }
        }
        return result;
    };
    Cache.prototype.refresh = function (now) {
        var _this = this;
        if (now || this.latency === 0) {
            if ((this.invalidator !== undefined || this.method.isTran) && !this.error)
                if (this.method.isAsync)
                    this.trap.apply(this, this.args).catch(function (error) { });
                else
                    this.trap.apply(this, this.args);
        }
        else
            setTimeout(function () { return _this.refresh(true); }, this.latency);
    };
    Cache.prototype.createTrap = function () {
        var _this = this;
        var self = this;
        var trap;
        if (this.method.isAsync)
            trap = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    var c;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                c = self;
                                if (!(c.method.isTran || c.invalidator !== undefined)) return [3, 2];
                                return [4, Transaction.runAsync.apply(Transaction, [c.hint, function () {
                                            var argsx = [];
                                            for (var _i = 0; _i < arguments.length; _i++) {
                                                argsx[_i] = arguments[_i];
                                            }
                                            return __awaiter(_this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    return [2, c.renewAsync.apply(c, argsx)];
                                                });
                                            });
                                        }].concat(args))];
                            case 1:
                                c = _a.sent();
                                _a.label = 2;
                            case 2:
                                c.owner.registerPropView(c.method.name, Ctx.cache);
                                return [2, c.value];
                        }
                    });
                });
            };
        else
            trap = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var c = self;
                if (c.method.isTran || c.invalidator !== undefined) {
                    c = Transaction.run.apply(Transaction, [c.hint, function () {
                            var argsx = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                argsx[_i] = arguments[_i];
                            }
                            return c.renew.apply(c, argsx);
                        }].concat(args));
                }
                c.owner.registerPropView(c.method.name, Ctx.cache);
                return c.value;
            };
        Tools.setHandle(trap, this);
        return trap;
    };
    Cache.prototype.renew = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var prop = this.method.name;
        var r = this.owner.handle.getForRenew(prop);
        var c = r.data[prop];
        if (c.method.isTran || c.invalidator !== undefined) {
            var c2_1 = r.data[prop] = new Cache(r, c.method, c.latency, Ctx.cache ? Ctx.cache.margin + 1 : 0);
            c2_1.args = args;
            c2_1.invalidator = undefined;
            c2_1.value = c2_1.run.apply(c2_1, [function () {
                    var argsx = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        argsx[_i] = arguments[_i];
                    }
                    var _a;
                    Tools.log(34, "║", "┌──", c2_1.hint + " - begin");
                    var result = (_a = c2_1.method.body).call.apply(_a, [c2_1.owner.handle.proxy].concat(argsx));
                    Tools.log(34, "║", "└──", c2_1.hint + " - end");
                    return result;
                }].concat(args));
            r.registerPropEdit(prop, Tools.notEqual(c, c2_1));
            c = c2_1;
        }
        if (c.error)
            throw c.error;
        return c;
    };
    Cache.prototype.renewAsync = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var prop, r, c, c2_2, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        prop = this.method.name;
                        r = this.owner.handle.getForRenew(prop);
                        c = r.data[prop];
                        if (!(c.method.isTran || c.invalidator !== undefined)) return [3, 2];
                        c2_2 = r.data[c.method.name] = new Cache(r, c.method, c.latency, Ctx.cache ? Ctx.cache.margin + 1 : 0);
                        c2_2.args = args;
                        c2_2.invalidator = undefined;
                        _a = c2_2;
                        return [4, c2_2.run.apply(c2_2, [function () {
                                    var argsx = [];
                                    for (var _i = 0; _i < arguments.length; _i++) {
                                        argsx[_i] = arguments[_i];
                                    }
                                    return __awaiter(_this, void 0, void 0, function () {
                                        var _a, result;
                                        return __generator(this, function (_b) {
                                            switch (_b.label) {
                                                case 0:
                                                    Tools.log(34, "║", "┌──", c2_2.hint + " - begin");
                                                    return [4, (_a = c2_2.method.body).call.apply(_a, [c2_2.owner.handle.proxy].concat(argsx))];
                                                case 1:
                                                    result = _b.sent();
                                                    Tools.log(34, "║", "└──", c2_2.hint + " - end");
                                                    return [2, result];
                                            }
                                        });
                                    });
                                }].concat(args))];
                    case 1:
                        _a.value = _b.sent();
                        r.registerPropEdit(prop, Tools.notEqual(c, c2_2));
                        c = c2_2;
                        _b.label = 2;
                    case 2:
                        if (c.error)
                            throw c.error;
                        return [2, c];
                }
            });
        });
    };
    Object.defineProperty(Cache.prototype, "hint", {
        get: function () { return this.owner.handle.hint + "t" + this.owner.transaction.id + "." + this.method.name.toString(); },
        enumerable: true,
        configurable: true
    });
    return Cache;
}());
var Tools = (function () {
    function Tools() {
    }
    Tools.getHandle = function (obj) {
        return obj[VARIO];
    };
    Tools.setHandle = function (obj, handle) {
        Object.defineProperty(obj, VARIO, { value: handle, configurable: false, enumerable: false });
        return handle;
    };
    Tools.acquireHandle = function (obj, store) {
        if (obj !== Object(obj) || Array.isArray(obj))
            throw new Error("E604: only objects can be registered in vario store");
        var h = Tools.getHandle(obj);
        if (!h) {
            if (Ctx.transaction)
                Transaction._acquireSnapshotNumber(Ctx.transaction);
            h = Tools.setHandle(obj, new Handle(store, obj));
        }
        return h;
    };
    Tools.hookArrayItem = function (array, index) {
        var t = array[index];
        var getter = function () { return t; };
        var setter = function (value) {
            var a = array;
            if (Object.isFrozen(a)) {
                var hp = Tools.getHandle(a);
                a = a.slice();
                hp.object[hp.property] = a;
            }
            a[index] = value;
        };
        var pd = Object.getOwnPropertyDescriptor(array, index);
        Object.defineProperty(array, index, { configurable: true, enumerable: pd ? pd.enumerable : true, get: getter, set: setter });
    };
    Tools.hookArrayMethod = function (array, method) {
        array[method.name] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var a = array;
            if (Object.isFrozen(a)) {
                var hp = Tools.getHandle(a);
                a = a.slice();
                hp.object[hp.property] = a;
            }
            return method.call.apply(method, [a].concat(args));
        };
    };
    Tools.freezeArray = function (arr, hp) {
        if (Tools.getHandle(arr))
            throw new Error("E610: array cannot be referenced from multiple objects");
        Tools.setHandle(arr, hp);
        for (var item in arr)
            Tools.hookArrayItem(arr, item);
        for (var _i = 0, _a = [arr.push, arr.pop, arr.shift, arr.sort, arr.splice, arr.unshift]; _i < _a.length; _i++) {
            var method = _a[_i];
            Tools.hookArrayMethod(arr, method);
        }
        Object.freeze(arr);
    };
    Tools.notEqual = function (oldValue, newValue) {
        var result;
        if (oldValue instanceof Cache) {
            if (newValue instanceof Cache)
                result = oldValue.value !== newValue.value;
            else if (newValue instanceof Function)
                result = oldValue.method.body !== newValue;
            else
                result = true;
        }
        else
            result = newValue !== oldValue;
        return result;
    };
    Tools.formatConflictsSummary = function (conflicts) {
        return conflicts.map(function (ours) {
            var items = [];
            ours.conflicts.forEach(function (theirs, prop) {
                items.push(Tools.formatConflictingProperty(prop, ours, theirs));
            });
            return items.join(", ");
        }).join(", ");
    };
    Tools.formatConflictingProperty = function (prop, ours, theirs) {
        return theirs.hint(prop);
    };
    Tools.link = function (prop, record, recordObservers, cache, cacheObservables) {
        if (!cache.dirty) {
            var caches_1 = recordObservers.get(prop);
            if (!caches_1)
                recordObservers.set(prop, caches_1 = new Set());
            caches_1.add(cache);
            var records = cacheObservables.get(prop);
            if (!records)
                cacheObservables.set(prop, records = new Set());
            records.add(record);
        }
        Tools.log(34, "║", "│ ∞", cache.owner.hint(cache.method.name) + " uses " + record.hint(prop) + (cache.dirty ? " (DIRTY)" : ""));
    };
    Tools.unlink = function (prop, observable, observableMask, observer, observerMask) {
        var observers = observableMask.get(prop);
        if (observers)
            observers.delete(observer);
        var observables = observerMask.get(prop);
        if (observables)
            observables.delete(observable);
    };
    Tools.log = function (color, ctx, op, message) {
        var t = Transaction.current;
        color = 31 + (t ? t.id : 0) % 6;
        ctx = t ? "t" + t.id + " " + ctx : "v" + Ctx.snapshot + " " + ctx;
        var margin = "│ ".repeat(Ctx.cache ? Ctx.cache.margin : 0);
        console.log("\x1b[37m%s\x1b[0m \x1b[" + color + "m%s\x1b[0m \x1b[" + color + "m%s%s\x1b[0m \x1b[" + color + "m%s\x1b[0m", "#vario", ctx, margin, op, message);
    };
    Tools.isAsync = function (func) {
        var string = func.toString().trim();
        return !!(string.match(/^async /) ||
            string.match(/return _ref[^\.]*\.apply/) ||
            string.match(/return __awaiter/));
    };
    Tools.rethrowError = function (error) {
        throw error;
    };
    return Tools;
}());
var originalThen = Promise.prototype.then;
Promise.prototype.then = function (onsuccess, onfailure) {
    var t = Ctx.transaction;
    if (t) {
        if (onsuccess) {
            onsuccess = Transaction._wrap(t, Ctx.cache, true, true, onsuccess);
            onfailure = Transaction._wrap(t, Ctx.cache, false, true, onfailure || Tools.rethrowError);
        }
        else if (onfailure)
            onfailure = Transaction._wrap(t, Ctx.cache, false, false, onfailure);
    }
    return originalThen.call(this, onsuccess, onfailure);
};
function statusof(method) {
    var result = { value: undefined, obsolete: false, error: undefined, latency: -1 };
    var c = Tools.getHandle(method);
    if (c instanceof Cache) {
        c.owner.registerPropView(c.method.name, Ctx.cache);
        result = { value: c.value, obsolete: c.invalidator !== undefined, error: c.error, latency: c.latency };
    }
    return result;
}
exports.statusof = statusof;
function autorenew(latency, method) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    var c = Tools.getHandle(method);
    if (c instanceof Cache) {
        c.args = args;
        c.latency = latency;
        if (latency >= 0)
            c.refresh(true);
    }
    else
        throw new Error("only cached method can be renewed automatically");
}
exports.autorenew = autorenew;
function dispose(obj) {
    if (obj) {
        var h = Tools.getHandle(obj);
        if (h && h instanceof Handle)
            h.dispose();
    }
}
exports.dispose = dispose;
exports.transactional = tran;
function tran(target, prop, descriptor) {
    if (prop) {
        if (descriptor)
            return memberDecorator(true, target, prop, descriptor);
        else
            return memberDecorator(false, target, prop);
    }
    else
        return classDecorator(target);
}
exports.tran = tran;
function cache(ctor, prop, descriptor) {
    return memberDecorator(false, ctor, prop, descriptor);
}
exports.cache = cache;
function classDecorator(target) {
    var origCtor = target;
    var newCtor = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return Transaction.run.apply(Transaction, [origCtor.name + ".ctor", function () {
                var argsx = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    argsx[_i] = arguments[_i];
                }
                var ctor = function () { return origCtor.call.apply(origCtor, [this].concat(argsx)); };
                ctor.prototype = origCtor.prototype;
                return new ctor();
            }].concat(args));
    };
    newCtor.prototype = origCtor.prototype;
    return newCtor;
}
function memberDecorator(isTran, proto, prop, pd) {
    var getter = function () {
        var h = Tools.acquireHandle(this, Ctx.store);
        var r = h.getForView();
        var result = r.data[prop];
        result instanceof Cache ? result = result.trap : r.registerPropView(prop, Ctx.cache);
        return result;
    };
    var setter = function (value) {
        var h = Tools.acquireHandle(this, Ctx.store);
        var r = h.getForEdit(prop, value);
        if (r)
            r.data[prop] = value;
    };
    if (pd && pd.value) {
        var vmt = proto[VARIO_VMT] || (proto[VARIO_VMT] = new Map());
        if (!proto.hasOwnProperty(VARIO_VMT))
            vmt = proto[VARIO_VMT] = new Map(vmt.entries());
        vmt.set(prop, new MethodInfo(isTran, prop, pd.value));
    }
    if (!pd)
        pd = Object.getOwnPropertyDescriptor(proto, prop);
    pd = { configurable: false, enumerable: pd ? pd.enumerable : true, get: getter, set: setter };
    return Object.defineProperty(proto, prop, pd);
}
Ctx.zerotran.commit();
//# sourceMappingURL=vario.js.map